"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.divisors = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const factorsOf_1 = require("./factorsOf");
const getCountDivisors_1 = require("./getCountDivisors");
function divisors(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._divisors !== undefined) {
		return n.divisors;
	}
	const factors = (0, factorsOf_1.factorsOf)(Math.abs(n.number));
	const dimensions = [];
	for (const index in factors) {
		dimensions.push([]);
		for (let x = 0; x <= factors[index].power; x++) {
			dimensions[index].push(Math.pow(factors[index].prime, x));
		}
	}
	const divSet = new Set();
	again(dimensions, 0, divSet, 1);
	if (n.number < 0) {
		for (const num of Array.from(divSet)) {
			divSet.add(num * -1);
		}
	}
	const divs = Array.from(divSet).sort((a, b) => a - b);
	if (divs.length !== (0, getCountDivisors_1.getCountDivisors)(n)) {
		throw new Error(
			`There is a problem with the divisors function - Contact the publisher`
		);
	}
	n.divisors = divs;
	return Array.from(n.divisors);
}
exports.divisors = divisors;
function again(dimensions, index, divs, sum) {
	if (!dimensions[index]) {
		divs.add(sum);
	} else {
		dimensions[index].forEach((v) =>
			again(dimensions, index + 1, divs, sum * v)
		);
	}
}
//# sourceMappingURL=divisors.js.map
