"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.factorsOf = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const sieve_1 = require("./sieve");
function factorsOf(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._factorsOf !== undefined) {
		return n.factorsOf;
	}
	let mutableN = Math.abs(n.number);
	const primesToN = (0, sieve_1.sieve)(mutableN);
	const factors = [];
	for (let k = 0; k < primesToN.length && mutableN > 1; k++) {
		const prime = primesToN[k];
		if (mutableN % prime === 0) {
			const factor = { prime, power: 0 };
			while (mutableN % prime === 0) {
				factor.power++;
				mutableN /= prime;
			}
			factors.push(factor);
		}
	}
	if (mutableN > 1) {
		factors.push({ prime: mutableN, power: 1 });
	}
	if (n.number < 0) {
		const negatives = [];
		for (const factor of factors) {
			negatives.push(Object.assign({}, factor));
			negatives[negatives.length - 1].prime *= -1;
		}
		factors.push(...negatives);
	}
	n.factorsOf = factors;
	return n.factorsOf;
}
exports.factorsOf = factorsOf;
//# sourceMappingURL=factorsOf.js.map
