"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPoliteness = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const isPowerOf2_1 = require("./isPowerOf2");
const isEven_1 = require("./isEven");
function getPoliteness(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._getPoliteness !== undefined) {
		return n.getPoliteness;
	}
	if ((0, isPowerOf2_1.isPowerOf2)(n)) {
		return 0;
	}
	let result = 1;
	let mutableN = n.number;
	while ((0, isEven_1.isEven)(mutableN)) {
		mutableN /= 2;
	}
	for (let i = 3; i * i <= mutableN; i += 2) {
		let divCount = 0;
		while (mutableN % i === 0) {
			mutableN /= i;
			++divCount;
		}
		result *= divCount + 1;
	}
	if (mutableN > 2) {
		result *= 2;
	}
	result--;
	n.getPoliteness = result;
	return n.getPoliteness;
}
exports.getPoliteness = getPoliteness;
//# sourceMappingURL=getPoliteness.js.map
