"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPractical = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const isPerfect_1 = require("./isPerfect");
const divisors_1 = require("./divisors");
const isPowerOf2_1 = require("./isPowerOf2");
const isSubsetSum_1 = require("./isSubsetSum");
function isPractical(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._isPractical !== undefined) {
		return n.isPractical;
	}
	if (n.number === 0) {
		n.isPractical = false;
		return n.isPractical;
	}
	if (n.number === 1 || n.number === 2) {
		n.isPractical = true;
		return n.isPractical;
	}
	if ((0, isPowerOf2_1.isPowerOf2)(n)) {
		n.isPractical = true;
		return n.isPractical;
	}
	if ((0, isPerfect_1.isPerfect)(n)) {
		n.isPractical = true;
		return n.isPractical;
	}
	if (n.number % 4 === 0 || n.number % 6 === 0) {
		const divs = (0, divisors_1.divisors)(n);
		for (let i = 1; i < n.number; i++) {
			if (!(0, isSubsetSum_1.isSubsetSum)(divs, divs.length, i)) {
				n.isPractical = false;
				return n.isPractical;
			}
		}
		n.isPractical = true;
		return n.isPractical;
	}
	n.isPractical = false;
	return n.isPractical;
}
exports.isPractical = isPractical;
//# sourceMappingURL=isPractical.js.map
