"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.semiperfectTest = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const divisors_1 = require("./divisors");
const getAliquotSum_1 = require("./getAliquotSum");
const sum_1 = require("./sum");
function semiperfectTest(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._semiperfectTest !== undefined) {
		return n.semiperfectTest;
	}
	let { difference, diffDivs, divs } = prepareNumberspace(n);
	if (
		pattern1(difference, diffDivs) ||
		jumpFromWrongDiv_1stJump(difference, diffDivs) ||
		jumpToWrongDiv_1stJump(difference, diffDivs) ||
		pattern1(n.number, divs) ||
		jumpFromWrongDiv_1stJump(n.number, divs) ||
		jumpToWrongDiv_1stJump(n.number, divs)
	) {
		return true;
	}
	return false;
}
exports.semiperfectTest = semiperfectTest;
function prepareNumberspace(n) {
	let difference = (0, getAliquotSum_1.getAliquotSum)(n) - n.number;
	let divs = (0, divisors_1.divisors)(n);
	divs.pop();
	divs.reverse();
	divs = reduceDivs(divs, difference);
	let diffDivs = Array.from(divs);
	diffDivs.pop();
	return { difference, diffDivs, divs };
}
function reduceDivs(divs, difference) {
	let number = (0, sum_1.sum)(divs.filter((v) => v > difference));
	divs = divs.filter((v) => !(v > difference));
	divs.push(number);
	return divs;
}
function pattern1(n, divs) {
	let num = 0;
	for (const div of divs) {
		if (num + div < n) {
			num += div;
		} else if (num + div === n) {
			return true;
		}
	}
	return false;
}
function jumpFromWrongDiv_1stJump(n, divs) {
	while ((0, sum_1.sum)(divs) >= n) {
		let num = 0;
		let jump = false;
		for (const div of divs) {
			if (num + div < n) {
				num += div;
			} else if (num + div === n) {
				return true;
			} else if (!jump) {
				jump = divs[divs.indexOf(div) - 1];
			}
		}
		divs = divs.filter((v) => v !== jump);
	}
	return false;
}
function jumpToWrongDiv_1stJump(n, divs) {
	while ((0, sum_1.sum)(divs) >= n) {
		let num = 0;
		let jump = false;
		for (const div of divs) {
			if (num + div < n) {
				num += div;
				if (jump === true) {
					jump = div;
				}
			} else if (num + div === n) {
				return true;
			} else if (jump === false) {
				jump = true;
			}
		}
		divs = divs.filter((v) => v !== jump);
		if (jump === true) {
			break;
		}
	}
	return false;
}
//# sourceMappingURL=semiperfectTest.js.map
