"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const atk = tslib_1.__importStar(require("advanced-testing-kit"));
const generators = tslib_1.__importStar(
	require("advanced-testing-kit/lib/numberGenerators")
);
const isTetrahedral_1 = require("../lib/isTetrahedral");
index();
function index() {
	let test = atk.makeTests(isTetrahedral_1.isTetrahedral, {
		returns: [
			[[220], true],
			[[220 + 1], !true],
			[[36180200], true],
			[[36180200 + 1], !true],
			[[121905300], true],
			[[121905300 + 1], !true],
			[[-120], true],
			[[-120 + 1], !true],
			[[-35820200], true],
			[[-35820200 + 1], !true],
			[[-121095300], true],
			[[-121095300 + 1], !true],
		],
		inputs: [
			[
				{
					type: Number,
					generator: generators.safePositiveInteger,
				},
			],
			[
				{
					type: Number,
					generator: generators.safeNegativeInteger,
				},
			],
		],
	});
	test();
}
//# sourceMappingURL=isTetrahedral.js.map
